#!/usr/bin/perl

$maillist = 'idfile';

$threshold = '85';
$for_real = 1;

%Id;

#
#  Get the qtree data from DFM in perl format.  This fills
#  in the reportKeys and reportData perl variables, among 
#  others.
#
#  Save the file in the current directory, too, to make
#  debugging easier.
#
sub get_qtree {
	system("dfm report -F perl qtrees-capacity >qtreefile");
	`cat qtreefile`;
}

#
#  Send a warning email message, using the list of 
#  qtree owners we read in at the beginning.
#
#  Customize the email message to taste.
#
sub send_mail {
	my $qtree = shift;
	my $usage = shift;

	if ($Id{$qtree}) {
		my $email = $Id{$qtree}->{'email'};
		my $name = $Id{$qtree}->{'name'};

		if ($for_real) {
			open(P, "| /usr/lib/sendmail -t") || die "Can't invoke sendmail: $!";
		}
		else {
			open(P, "| cat");
		}
		print P "To: ${name} <${email}>\n";
		print P "From: root\@buddha.lab.netapp.com\n";
		printf P "Subject: $qtree is %.1f%% full\n", $usage;
		print P "\n";
		print P "Insert your message here.\n";
		close(P);
		printf STDOUT "Notified $name about $qtree (%.1f%% full).\n",
				$usage;
	}
	else {
		printf STDERR "Error: Missing email for qtree $qtree ".
			"(%.1f%% full).\n", $usage;
	}
}

#
#  Read in the qtree-to-email mappings from $maillist.
#

open(E, $maillist) && do {
	while (<E>) {
		chop;
		split(/:/);
		$Id{$_[0]}->{'email'} = $_[1];
		$Id{$_[0]}->{'name'} = $_[2];
	}
	close(E);
};

eval &get_qtree;

my $cnt = 0;
my $over = 0;

for my $qtree (@reportKeys) {

	$cnt++;
	my $usage = $reportData{$qtree}->{'qtreeKBytesPercent'};
	if ($usage > $threshold) {
		$over++;
		& send_mail($reportData{$qtree}->{'objName'}, $usage);
	}
}

printf "Checked $cnt qtrees; $over were over threshold.\n";
